<?php
/*
*  @author Pagaddito <soporte@pagadito.com>
*  @copyright  2017 Pagadito
*
*  International Registered Trademark & Property of Pagadito
*
*  Description: Pagadito Payment controller
*/

include_once _PS_MODULE_DIR_.'pagaditops/libs/Pagadito_php_1.5.0.php';

class pagaditopspaymentModuleFrontController extends ModuleFrontController
{
    public function postProcess()
    {
        // Check that this payment option is still available in case the customer changed his address just before the end of the checkout process
        $authorized = false;
        foreach (Module::getPaymentModules() as $module) {
            if ($module['name'] == 'pagaditops') {
                $authorized = true;
                break;
            }
        }
        if (!$authorized) {
            die($this->module->l('This payment method is not available.', 'payment'));
        }

        //process payment
        $cart = $this->context->cart;
        if ($cart->id_customer == 0 || $cart->id_address_delivery == 0 || $cart->id_address_invoice == 0 || !$this->module->active) {
            Tools::redirect('index.php?controller=order&step=1');
        }

        $amount = $cart->getOrderTotal(true);
        $shipping = $cart->getTotalShippingCost();
        $taxes = $amount - $cart->getOrderTotal(false);
        $details = array();

        if ($cart->getOrderTotal(true, Cart::ONLY_DISCOUNTS) == 0) {
            foreach ($cart->getProducts() as $product) {
                $details[] = array((int) $product['cart_quantity'], $product['name'], (float) $product['price'], $product['link_rewrite']);
            }
            // shiping
            if ((float) $shipping > 0.00) {
                $details[] = array((int) 1, $this->l('Total shipping'), (float) $shipping, null);
            }
            // taxes
            if ((float) $taxes > 0.00) {
                $details[] = array((int) 1, $this->l('Total taxes'), (float) $taxes, null);
            }
        }

        $Pagadito_API = new Pagadito(Configuration::get('PAGADITO_UID'), Configuration::get('PAGADITO_WSK'));
        $Pagadito_API->enable_pending_payments();

        if (Configuration::get('PAGADITO_SANDBOX')) {
            $Pagadito_API->mode_sandbox_on();
        }

        if (!$Pagadito_API->connect()) {
            // error en el token
            die($this->module->l('connect ' . $Pagadito_API->get_rs_message(), 'payment'));
        }

        //$pagadito_token = $Pagadito_API->get_rs_value();


        foreach ($details as $detail) {
            $Pagadito_API->add_detail($detail[0], $detail[1], $detail[2], $detail[3]);
        }

        $currency = $this->context->currency;
        switch ($currency->iso_code) {
            
            case 'USD':
                
                $Pagadito_API->change_currency_usd();
                break;
            
            case 'GTQ':
                
                $Pagadito_API->change_currency_gtq();
                break;
            
            case 'HNL':
                
                $Pagadito_API->change_currency_hnl();
                break;
            
            case 'NIO':
                
                $Pagadito_API->change_currency_nio();
                break;
            
            case 'CRC':
                
                $Pagadito_API->change_currency_crc();
                break;
            
            case 'PAB':
                
                $Pagadito_API->change_currency_pab();
                break;
            
            case 'DOP':
                
                $Pagadito_API->change_currency_dop();
                break;
        }
        
        $response = $Pagadito_API->exec_trans($cart->id);
        if ($response) {
            Tools::redirect($response);
        }
    }
}
